---
published: true
layout: post
---
*Написал тут статью на хабр. Она долго лежала в песочнице. Потом я её вроде хотел поредактировать. Сохранил заново, видимо, она попалась на глаза модератору. Он её сначала пропустил на сайт, там её, конечно, заминусовали. А потом удалили вообще, сказали, что ошибка модератора. Такой день.*

*Текст статьи, раз уж на хабре её не ждут*

Оригинал тут:
[http://habrahabr.ru/post/274355/](http://habrahabr.ru/post/274355/)


## Бессилие умнейших или habralang...

Сколько стоит разработка инфраструктуры разработки? Чем собрать сборочный цех? Как запустить систему запуска? На все эти интересные вопросы приходится отвечать, когда приступаешь к очередному проекту. Когда ТЗ утверждено, наступает мучительный период выбора подходящих технологий. Кто-то выбирает фреймворк, кто-то прочёсывает каталоги расширений, кому-то нужны шаблоны. Всех этих людей объединяет одно — они не создают уже существующих фреймворков, не реализуют расширения, аналогичные зарегистрированным в каталоге, новых шаблонов тоже не пишут. Не плодят велосипеды. Не повторяют себя других. Решает задачи бизнеса оптимальным образом.

Работа в таком стиле неизбежно влияет на общие профессиональные навыки. Схожие профессиональные навыки многих людей формируют критерии оценки. Критерии становятся основой запросов индустрии к внешнему миру, к системе образования, к соискателям и даже к заказчикам.

Вполне нормальной считается ситуация, при которой знание определённых фреймворков (даже в отрыве от понимания их внутреннего устройства) выглядит преимуществом соискателя, а знание теории никак не влияет на успехи в поиске работы.

Можно привести пример многих ситуаций, каждый из которых только будет подтверждать нашу гипотезу о том, что удивительный мир программирования в своей основе почти всегда содержит массовые инфраструктурные продукты, проверенные временем. Это касается языков программирования, фреймворков и так далее.

И возвращаясь к началу рассуждения, постараемся дать ответ, кто же стоит за этими инфраструктурными продуктами? Две, три, десять компаний? Несколько консорциумов, в составе которых те же десять компаний? Да, стоит признать, что понятие монополий применимо не только к рыночным игрокам. Дальше больше. Так как технологии работают непосредственно, их нельзя юридически извратить, к ним нельзя применить процедуру банкротства или реорганизации, получается, что степень привязки ваших продуктов к инфраструктурным продуктам крайне высока. А где привязка, там и контроль. Влияние экосистемы на ваш продукт, ваш стиль работы, ваш разум, в конце концов.

Влияние экосистем нельзя было не заметить, и в какой-то момент это стало настолько очевидным, что даже холивары сошли на нет, так как зачастую люди из разных экосистем одинаковые слова интерпретируют по-своему. Особым образом смотрят на мир. Возникает несовместимость не только бинарных протоколов и объектно-реляционных моделей. Возникает несовместимость мировоззрений, и устранять её никто не намерен. Разделяй и управляй. При этом производители инфраструктурных продуктов готовы их даже бесплатно раздавать. Потому что понимают. Асимметрия информации работает на благо десяти компаний.

Ну и что плохого, спросите вы, это лишь разделение труда. Тут очевидный ответ один. Инфраструктурный проект не является целью работы компании. Целью работы компании является зарабатывание денег. А инфраструктурный проект это просто способ превратить много денег в средство привязки и контроля. К конкретной компании. Которая может пойти на дно. Которая может перестать вас любить. Google больше не против зла.

Ответной мерой, как многим кажется, является опенсурс-движение. Однако его возможности ограничены уже на уровне определений. Сложные многолетние проекты просто не потянуть. Никак. Ядро Linux? А сколько коммитов, в процентах, исходит всё от тех же корпораций. По сути, весь опенсурс это соглашение о влиянии корпораций в нейтральных водах. Специальная матрица для врагов матрицы. Выхода нет.

А ведь есть ещё и государства. Пока не устарели, не ушли в прошлое, как многим хочется. Государства имеют интересы, часто противоположные. А корпорации, возможно вопреки своему желанию, всё ещё существуют в рамках конкретных государств и волей-неволей, подчиняются законам этих государств. Следовательно, в какой-то момент международный бизнес и ИТ-шники всей планеты могут оказаться прежде всего лишь гражданами совершенно чужих государств. И поток уже существующих шаблонов, библиотек и фреймворков может прекратиться. Речь тут даже не о патриотизме и оппозиционности к власти государств, это банальный расчёт, если есть зависимость, разрешение которой зависит от факторов, которые вы не контролируете, то в один прекрасный момент зависимость просто не разрешится, проект не соберется и зарплату не выплатят.

Решений много, прежде всего предложат — «валить». Власть или в Америку. Неважно. Мы тут про ИТ. Наукоёмкие проекты. Веб-магазины в конце концов. Инфраструктура не зародится от сквозняка, даже если вы умнейший человек в стране и решили остаться ради принципа.

Исходя из всего этого лично мне с течением времени всё меньше понятны высказывания о ненужности существования в рамках отдельно взятой страны проживания, в великой и могучей Российской Федерации своей операционки, своих телефонов, своих языков программирования для разных сфер деятельности. Своё просто необходимо. А нету. А что есть? А есть смешки, шуточки и презрительный взгляд. «Опять болгенос, фуфу йоптафон, хахаха язык Дракон». И это понятно. Но непонятно, а на что же вы расчитываете?

Уйдут инженеры, программисты, забросят свои болгеносы, будут писать на этой вашей джаве, пока её не отключат. Все же пишут, вы что, самые умные чтоли? Интеллектуальное производство, напряжение ума. Думающие люди со светлыми лицами и европейским мировоззрением в свободное от работы время занимаются тем, что отговаривают коллег по цеху пилить РеактОС? Способы отговаривания тоже заслуживают внимания. Бери чужое, свой велосипед — это удел неразумных людей. Всё равно не получится так же качественно.

Конечно не получится, ребята. Ведь «там» люди делают своё. «Там» первородство. А «здесь» не делают своё. И не научатся. А кто умел, те разучатся. Или разучат. Это мы можем, с этим у нас всё просто. А ну, ребята, навались на выскочек и недоучек.

Даже стране уже не нужно воспитывать фанатов чужого. Она сама об этом говорит. Через обмуд омбуд одбум через своих глашатаев. Скоро и программистов своих не станет.

А заголовок ведь как раз про это? Кажется, целое поколение мировоззренчески не желает иметь ничего своего. И это объяснимо, это нормально. Но разумные люди должны уже наконец сделать выбор. Удручающая картина, тридцатилетние покорители ИТ-вершин бесплодно завершают своё творческое существование в Этой Стране, где место проклято и ничего не растёт, кроме коррупционеров. Но даже им нужно что-то своё, а вам?

А, ну «Эльбрусы», да. С компилятором американских язычков программирования Си/Си++.

На основании всех входных параметров алгоритм вычисления того, как нам дальше жить, должен дать ответ. Где habralang? Где продукт вашего ума сделанный так, как это нужно лично вам? В «Долине»? В Цюрихе? В Амстердаме? Может, в Чехии (где там jetBrains зарегистрированы вместе со своим Котлином)? Нужно нам своё или не нужно? Да или нет? 1 или 0? true или false? Или может, вспомним троичную логику?

Где habra language? Хотя бы в виде обсуждения? На гитхабе, на их площадке, ну и что? Где проекты, предложения? Никого, ничего, пустота и функциональное программирование, на хаскелле. На каком языке говорил автор Хаскелля?

*В комментариях сказали, что это ксенофобская хуйня. Ну вот и всё.*
